﻿@page "/changepassword"
@inject HttpClient Http
@inject NavigationManager NavigationManager
@inject AuthenticationStateProvider AuthStateProvider

<MudGrid Justify="Justify.Center">
    <MudItem xs="12" sm="8" md="6" lg="4" xl="3">
        <MudPaper Elevation="8" Class="pa-4">
            <MudTabs>
                <MudTabPanel Text="Change password">
                    <MudForm @ref="form" @bind-IsValid="isValid">
                        <MudTextField Label="First Name" Variant="Variant.Filled" @bind-Value="patchUserModel.FirstName" Required="true" RequiredError="First Name is required!" FullWidth />
                        <MudTextField Label="Last Name" Variant="Variant.Filled" @bind-Value="patchUserModel.LastName" Required="true" RequiredError="Last Name is required!" FullWidth />
                        <MudTextField Label="Current Password" Variant="Variant.Filled" @bind-Value="patchUserModel.CurrentPassword" Required="true" RequiredError="Current password is required!" FullWidth />
                        <MudTextField Label="New Password" Variant="Variant.Filled" @bind-Value="patchUserModel.NewPassword" Required="true" RequiredError="New password is required!" InputType="InputType.Password" FullWidth />
                        <MudButton Variant="Variant.Filled" Color="Color.Primary" Class="mt-4" OnClick="HandlPatch">Change password</MudButton>
                    </MudForm>
                </MudTabPanel>
            </MudTabs>
        </MudPaper>
    </MudItem>
</MudGrid>

@code {
    private MudForm form;
    private PatchUserModel patchUserModel = new PatchUserModel();
    private bool isValid;
    private bool loginFailed;
    private string errorMessage;

    private async Task HandlPatch()
    {
        await form.Validate();

        if (isValid)
        {
            var success = await PatchAsync(patchUserModel);
            if (success)
            {
                NavigationManager.NavigateTo("/showusers");
            }
            else
            {
                loginFailed = true;
                errorMessage = "Wrong credentials, please check and try again.";
            }
        }
    }

    public async Task<bool> PatchAsync(PatchUserModel patchUserModel)
    {
        var response = await Http.PatchAsJsonAsync("/api/Users", patchUserModel);
        if (response.IsSuccessStatusCode)
        {
            var authResponse = await response.Content.ReadFromJsonAsync<PostAuthenticationResponseModel>();
            await ((CustomAuthenticationStateProvider)AuthStateProvider).MarkUserAsAuthenticated(authResponse);
            return true;
        }
        else return false;
    }
}
